using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Globalization;

namespace PageBox
{
	/// <summary>
	/// <p>Generated.<br/>
	/// Methods modified or created:<ul>
	/// <li>Page_Load</li></ul>
	/// <p>Copyright (c) 2002 Alexis Grandemange<br/>
	/// Mail: alexis.grandemange@pagebox.net</p>
	/// <pre>This program is free software; you can redistribute it and/or
	/// modify it under the terms of the GNU Lesser General Public
	/// License as published by the Free Software Foundation; version
	/// 2.1 of the License.
	/// This library is distributed in the hope that it will be useful,
	/// but WITHOUT ANY WARRANTY; without even the implied warranty of
	/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	/// GNU Lesser General Public License for more details.
	/// A copy of the GNU Lesser General Public License lesser.txt should be
	/// included in the distribution.</pre>
	/// </summary>
	public class UpdateWF : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.HyperLink logo;
		protected System.Web.UI.WebControls.HyperLink Support;
		protected System.Web.UI.WebControls.Label LabWSURL;
		protected System.Web.UI.WebControls.Label UpdateLab;
		protected System.Web.UI.WebControls.DataGrid updateDB;
	
		public UpdateWF()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		/// <summary>
		/// <p>Called on Page Load event.<ul>
		/// <li>Populates an array of UpdateEntry and binds this array to updateDB datagrid</li>
		/// <li>Set the Web service URL on LabWSURL</li></ul>
		/// </summary>
		private void Page_Load(object sender, System.EventArgs e)
		{
			ArrayList al = new ArrayList();
			IDictionaryEnumerator ide = Global.pbArchives.archives.GetEnumerator();
			while(ide.MoveNext()) 
			{
				string a = (string)ide.Key;
				Archive arch = (Archive)ide.Value;
				al.Add(new UpdateEntry(a, arch.downloadURL,
					arch.date.ToString("u", DateTimeFormatInfo.InvariantInfo),
					arch.owner, arch.docURL, "" + arch.size));
			}
			updateDB.DataSource = al;
			updateDB.DataBind();
			LabWSURL.Text = Global.DeployURL;
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
	 /// <summary>
	 /// Describes a row of updateDB datagrid.
	 /// </summary>
	public sealed class UpdateEntry 
	{
		/// <summary>
		/// Archive name.
		/// </summary>
		private string archive;
		/// <summary>
		/// Repository URL.
		/// </summary>
		private string downloadURL;
		/// <summary>
		/// Archive Last Modified time.
		/// </summary>
		private string date;
		/// <summary>
		/// User who published the archive.
		/// </summary>
		private string owner;
		/// <summary>
		/// URL of the archive documentation.
		/// </summary>
		private string doc;
		/// <summary>
		/// Archive size (in bytes)
		/// </summary>
		private string size;

		/// <summary>
		/// Constructor.
		/// </summary>
		/// <param name="a">Archive name</param>
		/// <param name="u">Download URL</param>
		/// <param name="t">Archive Last Modified time</param>
		/// <param name="o">User who published the archive</param>
		/// <param name="d">URL of the archive documentation</param>
		/// <param name="s">Archive size</param>
		public UpdateEntry(string a, string u, string t, string o, string d, string s) 
		{
			archive = a;
			downloadURL = u;
			date = t;
			owner = o;
			doc = d;
			size = s;
		}
		/// <value>
		/// Archive name
		/// </value>
		public string Archive 
		{
			get { return archive; }
		}
		/// <value>
		/// Download URL
		/// </value>
		public string DownloadURL 
		{
			get { return downloadURL; }
		}
		/// <value>
		/// Archive Last Modified time
		/// </value>
		public string Date 
		{
			get { return date; }
		}
		/// <value>
		/// User who published the archive
		/// </value>
		public string Owner 
		{
			get { return owner; }
		}
		/// <value>
		/// URL of the archive documentation
		/// </value>
		public string Documentation 
		{
			get { return doc; }
		}
		/// <value>
		/// Archive size
		/// </value>
		public string Size 
		{
			get { return size; }
		}
	}
}
